use CGI::Carp qw(fatalsToBrowser);
###############################################################################
# Mask.pl                                                                     #
###############################################################################
# Author:         Valtiel                                                     #
# Version:        1.2 YaBB 2.1                                                #
# Released:       05/31/2006                                                  #
###############################################################################

sub DoMaskUBBC {
	$type = "url";
	$message =~ s~\[maskurl\]\s*www\.(\S+?)\s*\[/maskurl\]~&Mask($1,$type)~eisg;
	$message =~ s~\[maskurl=\s*(\S\w+\://\S+?)\s*\](.+?)\[/maskurl\]~&Mask($1,$2,$type)~eisg;
	$message =~ s~\[maskurl=\s*(\S+?)\](.+?)\s*\[/maskurl\]~&Mask($1,$2,$type)~eisg;
	$message =~ s~\[maskurl\]\s*(\S+?)\s*\[/maskurl\]~&Mask($1,$type)~eisg;

	$type = "plain";
	$message =~ s~\[mask\](.+?)\[/mask\]~&Mask($1,$type)~eisg;

	$type = "img";
	$message =~ s~\[maskimg\](?:\s|\t|\n|$hardspace|$char_160)*(http\:\/\/)*(.+?)(?:\s|\t|\n|$hardspace|$char_160)*\[/maskimg\]~&Mask($2,$type)~eisg;

	$type = "restrictimg";
	$message =~ s~\[maskimg width=(\d+) height=(\d+)\](?:\s|\t|\n|$hardspace|$char_160)*(http\:\/\/)*(.+?)(?:\s|\t|\n|$hardspace|$char_160)*\[/maskimg\]~restrictmaskedimage($1,$2,'http://'.$4)~eisg;

	if (-e ("$sourcedir/MediaCenter.pl")) {
	require "$sourcedir/MediaCenter.pl";

	$type = "media";
	$message =~ s~\[maskmedia\]\n*(.*?)\n*\[/maskmedia\]~&Mask($1,$type)~eisg;
	while ($message =~ s~\[maskmedia\]\n*(.*?)\n*\[/maskmedia\]~&embed($1)~eisg){ }

	$type = "controlledmedia";
	$message =~ s~\[maskmedia\s*(.*?)\]\n*(.*?)\n*\[/maskmedia\]~&Mask($2,$1,$type)~eisg;
	while ($message =~ s~\[maskmedia\s*(.*?)\]\n*(.*?)\n*\[/maskmedia\]~&embed($2,$1)~eisg){ }

	$message =~ s~media:~http:~ig;
	}

	sub restrictmaskedimage {
		my ($w, $h, $s) = @_;
		$w = $w <= $MAXIMGWIDTH  ? $w : $MAXIMGWIDTH;
		$h = $h <= $MAXIMGHEIGHT ? $h : $MAXIMGHEIGHT;
		$source = $s;
		$width = $w;
		$height = $h;
		&Mask($source,$width,$height,$type);
		return qq~$maskedresult~;
	}
}

sub Mask {
	if ($type eq "url" || $type eq "plain") {
		$urltomask = $1;
		$description = $2;
	} elsif ($type eq "img") {
		$urltomask = $2;
	} elsif ($type eq "restrictimg") {
		$urltomask = $source;
		$imgwidth = $width;
		$imgheight = $height;
	} elsif ($type eq "media") {
		&GetMediaFileType($1);
		$urltomask = $1;
	} elsif ($type eq "controlledmedia") {
		&GetMediaFileType($2);
		$urltomask = $2;
		$mediacontrol = $1;
	} else {
		$urltomask = $1;
	}

	if ($urltomask !~ m/^http:\/\//) {
		$urltomask = "http://$urltomask";
	}

	$random = rand(100000);
	($first, $second) = split(/\./, $random);
	$random = "$first$second";

	fopen (FILE, "$vardir/maskedstuff.txt");
	@maskedurls = <FILE>;
	fclose (FILE);
	 foreach $maskedurl (@maskedurls) {
	 	chomp $maskedurl;
		($originalurl, $mask) = split(/\|/, $maskedurl);
			if ($urltomask eq $originalurl) {
			$entryfound = 1;
			last;
		} else {
			$entryfound = 0;
		}
	}

	if ($entryfound == 0) {
		fopen (FILE, ">>$vardir/maskedstuff.txt");
		print FILE "$urltomask|$random\n";
		fclose (FILE);
	} else {
		$random = $mask;
	}

	if ($type eq "url" && $description eq '') {
		$urldescription = "Masked link";
	} else {
		$urldescription = $description;
	}

	if ($type eq "url") {
		$maskedresult = "<a href='$boardurl/YaBB.$yyext?action=demask;mask=$random;type=url' target='_blank'>$urldescription</a>";
	} elsif ($type eq "plain") {
		$maskedresult = "$boardurl/YaBB.$yyext?action=demask;mask=$random;type=plain";
	} elsif ($type eq "img") {
		$maskedresult = "<img src='$boardurl/YaBB.$yyext?action=demask;mask=$random;type=img' alt='' border='0'>";
	} elsif ($type eq "restrictimg") {
		$maskedresult = "<img src='$boardurl/YaBB.$yyext?action=demask;mask=$random;type=img' width='$imgwidth' height='$imgheight' alt='' border='0'>";
	} elsif ($type eq "media" && $mediafiletype ne "nomedia") {
		$maskedresult = "\[media\]$boardurl\/YaBB.$yyext?action=demask;type=media;mask=$random.$mediafiletype\[\/media\]";
	} elsif ($type eq "controlledmedia" && $mediafiletype ne "nomedia") {
		$maskedresult = "\[media $mediacontrol\]$boardurl\/YaBB.$yyext?action=demask;type=media;mask=$random.$mediafiletype\[\/media\]";
	} else {
		$maskedresult = "$boardurl/YaBB.$yyext?action=demask;mask=$random;type=plain";
	}

	return $maskedresult;
}

sub GetMediaFileType {
# Video Media Player
  my ($urltomask) = @_;
	if ($urltomask =~ m/.wmv$/i) {
		$mediafiletype = "wmv";
	} elsif ($urltomask =~ m/.wpl$/i) {
		$mediafiletype = "wpl";
	} elsif ($urltomask =~ m/.asf$/i) {
		$mediafiletype = "asf";
	} elsif ($urltomask =~ m/.avi$/i) {
		$mediafiletype = "avi";
	} elsif ($urltomask =~ m/.mpg$/i) {
		$mediafiletype = "mpg";
	} elsif ($urltomask =~ m/.mpeg$/i) {
		$mediafiletype = "wpl";
# Audio Media Player
	} elsif ($urltomask =~ m/.wma$/i) {
		$mediafiletype = "wma";
	} elsif ($urltomask =~ m/.wax$/i) {
		$mediafiletype = "wax";
	} elsif ($urltomask =~ m/.asx$/i) {
		$mediafiletype = "asx";
	} elsif ($urltomask =~ m/.mp3$/i) {
		$mediafiletype = "mp3";
	} elsif ($urltomask =~ m/.mid$/i) {
		$mediafiletype = "mid";
	} elsif ($urltomask =~ m/.wav$/i) {
		$mediafiletype = "wav";
	} elsif ($urltomask =~ m/.kar$/i) {
		$mediafiletype = "kar";
	} elsif ($urltomask =~ m/.rmi$/i) {
		$mediafiletype = "rmi";
# Real Player
	} elsif ($urltomask =~ m/.ra$/i) {
		$mediafiletype = "ra";
	} elsif ($urltomask =~ m/.ram$/i) {
		$mediafiletype = "ram";
	} elsif ($urltomask =~ m/.rm$/i) {
		$mediafiletype = "rm";
# QuickTime Player
	} elsif ($urltomask =~ m/.qt$/i) {
		$mediafiletype = "qt";
	} elsif ($urltomask =~ m/.qtm$/i) {
		$mediafiletype = "qtm";
	} elsif ($urltomask =~ m/.mov$/i) {
		$mediafiletype = "mov";
	} else {
		$mediafiletype = "nomedia";
	}
	return $mediafiletype;
}


sub Demask {
	if($username eq "Guest" && $INFO{'type'} ne "media") {
		$destination = "$scripturl?action=register";
	} else {
		if ($INFO{'type'} eq "media") {
		 	($mediamask, $mediatype) = split(/\./, $INFO{'mask'});
		 	$urltodemask = $mediamask;
		} else {
			$urltodemask = $INFO{'mask'};
		}

	fopen (FILE, "$vardir/maskedstuff.txt");
	@maskedurls = <FILE>;
	fclose (FILE);
	 foreach $maskedurl (@maskedurls) {
	 	chomp $maskedurl;
	 	($originalurl, $maskedurl) = split(/\|/, $maskedurl);
	 		if ($maskedurl eq $urltodemask) {
	 			$destination = $originalurl;
	 			last;
	 		}
	 	}
	}

	if ($INFO{'type'} eq "url" || $INFO{'type'} eq "plain") {
		print "Content-Type: text/html\n\n";
		$iframe = qq~<html>\n<head>\n<title>Masked!</title>\n</head>\n<iframe frameborder="0" src="$destination" width="100%" height="100%"><p>Your browser is not able to display iFrames</p></iframe>\n</html>\n~;
		print $iframe;
		exit;
	} else {
		print "HTTP/1.0 302 Temporary Redirection\r\n" if $ENV{PERLXS} eq "PerlIS";
		print "Content-type: text/html\n";
		print "Location: $destination\n\n";
		exit;
	}
}

sub KillMaskDatabase {
	&is_admin_or_gmod;
	unlink ("$vardir/maskedstuff.txt");
	$yySetLocation = qq~$scripturl~;
	&redirectexit;
}

1;